chiark / gitweb /
dot/ipython-key-bindings.py: Hack IPython's bogus keybindings.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
563555cf 13: ${REPO=https://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
d8070b21 136 vimrc mg zile lesskey sqliterc
bb65ad08 137 parallel-config:.parallel/config
1344a0a4 138 ipython-config.py:.ipython/profile_default/ipython_config.py
bff12eb1 139 ipython-key-bindings.py:.ipython/profile_default/startup/50-key-bindings.py
30169591 140 ditz-config
ce39049e 141 mailrc signature muttrc
ce178f96 142 cgrc tigrc
e7d23024 143 gdbinit
8a7e906d 144 guile
1d89ce86 145 rcrc
5d25e440 146 toprc
a6a6806a 147 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
f56d38cd 148 pulse-daemon.conf:.pulse/daemon.conf
cbffcf2b 149 aspell.conf
78719982 150 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
151 lisp-init.lisp:.cmucl-init.lisp
152 lisp-init.lisp:.sbclrc
153 lisp-init.lisp:.clisprc.lisp
f6335a0c 154 lisp-init.lisp:.eclrc
b5bf3445 155 swank.lisp
5a91acc5 156 mdw-build.conf:.config/mdw-build.conf
3ec64a11 157 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
4d60a7ac 158 dircolors colordiffrc screenrc tmux.conf cvsrc indent.pro"
739bccbf 159[ "$xstuff" ] && dotfiles="$dotfiles
f7cb5c84 160 xinitrc xsession xmodmap vncrc vncsession
5e23020b 161 fonts.conf
e517857c 162 stalonetrayrc
1c6b19d4 163 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 164 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 165 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 166 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 167 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
e8aee51b
MW
168 e16-bindings:.e16/bindings.cfg
169 gtkrc-2.0
170 gtk3.css:.config/gtk-3.0/gtk.css
171 gtk3-settings.ini:.config/gtk-3.0/settings.ini"
f617db13
MW
172echo "Installing dotfiles..."
173for d in $dotfiles; do
739bccbf
MW
174 target=.$d
175 case $d in
176 *:*) target=${d#*:} d=${d%%:*};;
177 esac
178 ft=$HOME$sub/$target
179 dir=${ft%/*}
180 mkdir -p $dir
99063107 181 ln -s $here/dot/$d $ft.new
739bccbf
MW
182 mv $ft.new $ft
183 echo " $target"
f617db13 184done
852cd5fb 185echo " all done."
f617db13 186
f7cb5c84
MW
187## CPP-hack files which need it.
188cppfiles=""
189[ "$xstuff" ] && cppfiles="$cppfiles
190 Xdefaults"
191echo "Hacking files with C preprocessor..."
c7203018 192defs="-DHOME=$HOME -DPROFILE=$here"
a1c9c51e 193defs="$defs -DEMACSWD=$(bin/mdw-conf emacs-width 77)"
f7cb5c84
MW
194for c in $cppfiles; do
195 target=.$c
196 case $c in
197 *:*) target=${c#*:} c=${c%%:*};;
198 esac
199 ft=$HOME$sub/$target
200 dir=${ft%/*}
201 mkdir -p $dir
c7203018 202 cpp -P $defs dot/$c -o $ft.new
f7cb5c84
MW
203 mv $ft.new $ft
204 echo " $target"
205done
206echo " all done."
207
403dc178
MW
208## Substitute things which need substituting.
209dotfilessubst="
210 gitconfig
8508a859 211 mykermrc
403dc178
MW
212 pulse-default.pa.in:.pulse/default.pa"
213echo "Installing dotfiles with substitutions..."
214for d in $dotfilessubst; do
215 case $d in
216 *:*) target=${d#*:} d=${d%%:*};;
217 *) target=.$d d=$d.in;;
218 esac
219 ft=$HOME$sub/$target
220 dir=${ft%/*}
221 mkdir -p $dir
222 sed "
2b5d4580
MW
2231i\\
224### generated by $here/setup; do not edit!\\
403dc178
MW
225
226/@home@/ s\a\a$HOME\ag
73165cde 227/@profile@/ s\a\a$here\ag
bf674ae1 228/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
229" dot/$d >$ft.new
230 mv $ft.new $ft
231 echo " $target"
232done
233echo " all done."
234
f4e43257 235## Symlink backgrounds.
b8d76a42 236backgrounds=$(cd bg && echo *)
f4e43257
MW
237if [ "$xstuff" ]; then
238 echo "Installing backgrounds..."
239 for b in $backgrounds; do
240 for e in enlightenment e16; do
241 dir=$HOME$sub/.$e/backgrounds
242 t=$dir/$b
243 mkdir -p $dir
99063107 244 ln -s $here/bg/$b $t.new
f4e43257
MW
245 mv $t.new $t
246 done
247 echo " $b"
248 done
249 echo " all done."
250fi
251
ce178f96
MW
252###--------------------------------------------------------------------------
253### Install useful scripts included in this package.
254
e04c4857 255scripts="
547fb8af 256 mdw-editor
b20bfd83 257 mdw-pager
b056f5c4 258 mdw-conf
b94830d9 259 mdw-build mdw-sbuild mdw-sbuild-server
5f56828b 260 update-buildable-branch
c4e84cb1 261 emacsclient-hack
8e08f814 262 movemail-hack
aaa2d943 263 sendmail-hack
68b2e9e6 264 aspell-hack
285a1386
MW
265 emerge-hack
266 lesspipe.sh
6a5170a8 267 run-with-shell-env
285a1386 268 start-ssh-agent
6a5170a8 269 start-ssh-pageant
6ffd4490 270 add-ssh-keys
4cdeb0d0 271 svnwrap
73bb9001 272 guest-console
4cdeb0d0 273 hyperspec"
8e08f814 274[ "$xstuff" ] && scripts="$scripts
3bdada49 275 xinitcmd
34a5ea4e 276 un-backslashify-selection
c02999e8 277 lock-screen
b7743290 278 xpra-start-xdummy
8e08f814 279 xshutdown"
e04c4857
MW
280echo "Installing scripts..."
281mkdir -p $HOME$sub/bin
282for s in $scripts; do
283 ft=$HOME$sub/bin/$s
99063107 284 ln -s $here/bin/$s $ft.new
e04c4857
MW
285 mv $ft.new $ft
286 echo " $s"
287done
288echo " all done."
289
4d7d040b
MW
290hacks="
291 ssh:ssh"
292echo "Installing hacks..."
293for h in $hacks; do
294 d=${h%%:*} h=${h#*:}
295 ft=$HOME$sub/bin/hacks/$d
296 mkdir -p $ft
297 ln -s $here/hacks/$h $ft/$h.new
298 mv $ft/$h.new $ft/$h
299 echo " $d:$h"
300done
301echo " all done."
302
ce178f96
MW
303###--------------------------------------------------------------------------
304### Set up the Emacs config.
305
65ff0e8c
MW
306$echon "Finding a suitable emacs:$echoc"
307emacs=no
936b7279 308for i in emacs24 emacs23 emacs22 emacs21 emacs; do
65ff0e8c
MW
309 if type -p >/dev/null $i; then
310 emacs=$i
311 break
312 fi
313done
314if [ $emacs = no ]; then
315 echo " failed."
316 emacs=:
317else
318 echo " $emacs."
319fi
320
f617db13 321echo "Installing Emacs packages..."
400223a1
MW
322emacspkg="
323 make-regexp
a1293ade 324 ew-hols
a3bdb4d9 325 mdw-gnus-patch
1778b496 326 git git-blame vc-git stgit
c6fe19d5 327 mdw-multiple-cursors
400223a1
MW
328 quilt"
329for elib in $emacspkg; do
f617db13 330 $echon " $elib:$echoc"
65ff0e8c 331 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 332 (progn
852cd5fb
MW
333 (setq load-path (nconc load-path (list "~/lib/emacs")))
334 (kill-emacs (condition-case nil
335 (progn (load-library "'"$elib"'") 0)
20eb0692 336 (error 1))))'; then
f617db13
MW
337 echo " already installed."
338 else
99063107
MW
339 if [ -f el/$elib.el ]; then
340 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
341 else
342 $echon " downloading$echoc"
343 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
344 fi
f617db13
MW
345 $echon " compiling$echoc"
346 (cd $HOME$sub/lib/emacs;
65ff0e8c 347 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 348 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
349 echo " done."
350 fi
351done
852cd5fb 352echo " all done."
f617db13
MW
353
354$echon "Setting up Emacs configuration:$echoc"
355$echon " linking$echoc"
99063107 356for f in dot-emacs.el Makefile; do
f617db13 357 set -- $(echo $link | tr : ' ')
99063107
MW
358 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
359 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
360done
361$echon " compiling$echoc"
c39d1139 362{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 363echo " done."
ce178f96
MW
364
365###----- That's all, folks --------------------------------------------------